SystemOrganization addCategory: #GODFilter!

Object subclass: #FILTMainFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODFilter'!

FILTMainFilter subclass: #FILTConferenceFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODFilter'!

!FILTConferenceFilter methodsFor: 'accessing' stamp: 'CER 10/18/2014 19:20'!
filter: collectionOfGodConference byGCSearchFilter: searchFilter
	"Filter a collection of GODConference by GCSearchFilter"

	| result |
	result := OrderedCollection new.
	
	collectionOfGodConference do: [: each |
		((searchFilter searchKey match: each name) & 
		(each categories = searchFilter category) & 
		((each importantDates) deadlineDate <= (each importantDates) startDate) & 
		((each importantDates) startDate <= (each importantDates) endDate) &
		((each importantDates) deadlineDate <= searchFilter deadlineDate) & 
		((each importantDates) startDate >= searchFilter startDate) & 
		((each importantDates) endDate <= searchFilter endDate))
		ifTrue: [result add: each]].
	^result.! !

!FILTMainFilter methodsFor: 'accessing' stamp: 'LM 10/9/2014 19:32'!
filter: collectionOfGodData byContent: aString
	"Filter a collection of GODData by content"

	| result |
	result := OrderedCollection new.
	
	collectionOfGodData do: [: each |
		(aString match: each content)
		ifTrue: [result add: each]].
	^result.! !

!FILTMainFilter methodsFor: 'accessing' stamp: 'LM 10/9/2014 19:31'!
filter: collectionOfGodData byOrigin: aString
	"Filter a collection of GODData by origin"

	| result |
	result := OrderedCollection new.
	
	collectionOfGodData do: [: each |
		(aString match: each origin)
		ifTrue: [result add: each]].
	^result.! !

!FILTMainFilter methodsFor: 'accessing' stamp: 'LM 10/9/2014 19:33'!
filter: collectionOfGodData byTags: aString
	"Filter a collection of GODData by tags"

	| result |
	result := OrderedCollection new.
	
	collectionOfGodData do: [: each |
		each tags do: [:tag |
			(aString match: tag)
			ifTrue: [result add: each].
		]].
	^result. ! !

!FILTMainFilter methodsFor: 'accessing' stamp: 'LM 10/9/2014 19:31'!
filter: collectionOfGodData byTitle: aString
	"Filter a collection of GODData by title"

	| result |
	result := OrderedCollection new.
	
	collectionOfGodData do: [: each |
		(aString match: each title)
		ifTrue: [result add: each]].
	^result.! !

FILTMainFilter subclass: #FILTSocialFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODFilter'!

FILTMainFilter subclass: #FILTTextFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GODFilter'!

!FILTTextFilter methodsFor: 'accessing' stamp: 'LM 10/16/2014 18:29'!
filterText: text between: startMark and: endMark 
	"Filter a string considering an initial tag and a final tag"

	| result textSize initialIndex finalIndex index startMarkSize endMarkSize resultString |
	result := OrderedCollection new.
	textSize := text size.	
	initialIndex := text findString: startMark.
	finalIndex := text findString: endMark startingAt: initialIndex.
	startMarkSize := startMark size.
	endMarkSize := endMark size.

	((initialIndex ~= 0) & (finalIndex ~= 0) & (finalIndex > initialIndex)) ifTrue: [ 
		[(finalIndex ~= 0)] whileTrue: [
			index := text findString: startMark startingAt: initialIndex + 1.
			(index = 0) ifTrue: [resultString := text copyFrom: (initialIndex + startMarkSize) to: (finalIndex - 1).
   						           result add: resultString.
							     finalIndex := 0.]
						ifFalse: [(index > finalIndex) ifTrue: [ resultString := text copyFrom: (initialIndex + startMarkSize) to: (finalIndex - 1).
												  			 result add: resultString.
															 initialIndex := index.
															 finalIndex := text findString: endMark startingAt: initialIndex + 1.
															]
													ifFalse: [ (index > initialIndex) ifTrue: [ initialIndex := index. ]]].
						].].
	^result.! !
